(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('angular-in-memory-web-api'), require('@angular/common/http'), require('angular-in-memory-web-api/delay-response'), require('rxjs'), require('uuid'), require('@angular/core')) :
    typeof define === 'function' && define.amd ? define('totvs-log-web-foundation/src/in-memory-data', ['exports', 'angular-in-memory-web-api', '@angular/common/http', 'angular-in-memory-web-api/delay-response', 'rxjs', 'uuid', '@angular/core'], factory) :
    (global = global || self, factory((global['totvs-log-web-foundation'] = global['totvs-log-web-foundation'] || {}, global['totvs-log-web-foundation'].src = global['totvs-log-web-foundation'].src || {}, global['totvs-log-web-foundation'].src['in-memory-data'] = {}), global.angularInMemoryWebApi, global.ng.common.http, global.delayResponse, global.rxjs, global.uuid, global.ng.core));
}(this, function (exports, angularInMemoryWebApi, http, delayResponse, rxjs, uuid, core) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */

    function __values(o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m) return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} req
     * @return {?}
     */
    function getRequestMethod(req) {
        if (req.url.endsWith('/alterar') || req.url.endsWith('/editar')) {
            return 'put';
        }
        else if (req.url.endsWith('/excluir') || req.url.endsWith('/deletar')) {
            return 'delete';
        }
        else {
            return (req.method || 'get').toLowerCase();
        }
    }
    // tslint:disable: no-string-literal
    /**
     * @param {?} dbService
     * @param {?} options
     * @param {?} xhrFactory
     * @return {?}
     */
    function httpClientInMemBackendServiceFactory(dbService, options, xhrFactory) {
        /** @type {?} */
        var backend = new angularInMemoryWebApi.HttpClientBackendService(dbService, options, xhrFactory);
        backend['getRequestMethod'] = getRequestMethod.bind(backend);
        return backend;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // tslint:disable: no-string-literal
    var   
    // tslint:disable: no-string-literal
    InMemoryDataService = /** @class */ (function () {
        function InMemoryDataService() {
            this.loadsFn = [];
            this.requestInterceptors = [];
            this.replaceMap = new Map();
            this.searchTermMap = new Map();
            this.transformGetMap = new Map();
            this.transformPostMap = new Map();
            this.transformPutMap = new Map();
            this.fieldsFilterMap = new Map();
            this.dbe2e = new Map();
            this.responseUtils = this.getResponseUtils();
            this.config = getMemoryConfig();
            console.log('[In-Memory]', 'Configuration: ', this.config);
            window['inMemoryDataService'] = this;
        }
        /**
         * @return {?}
         */
        InMemoryDataService.prototype.createDb = /**
         * @return {?}
         */
        function () {
            return rxjs.of({});
        };
        /**
         * @return {?}
         */
        InMemoryDataService.prototype.deleteDatabase = /**
         * @return {?}
         */
        function () {
            var _this = this;
            /** @type {?} */
            var result$ = new Promise((/**
             * @param {?} resolve
             * @param {?} reject
             * @return {?}
             */
            function (resolve, reject) {
                // Para testes e2e usa o banco de dados em memória mesmo
                if (_this.config.memoryOnly) {
                    console.log('[In-Memory]', 'Deleted e2e OK!');
                    resolve(true);
                }
                else {
                    /** @type {?} */
                    var request = indexedDB.deleteDatabase(_this.config.databaseName);
                    /** @type {?} */
                    var errorResponse_1 = (/**
                     * @param {?} event
                     * @return {?}
                     */
                    function (event) {
                        console.log('[In-Memory]', 'Error deleting the DB');
                        /** @type {?} */
                        var mensagem = 'Não foi possível excluir o banco de dados da memória.\n' +
                            'Verifique se você está com outra aba aberta com a aplicação.\n' +
                            'Este comportamento é necessário para ter a garantia de sempre recriar o banco de dados.';
                        alert(mensagem);
                        reject(((/** @type {?} */ (event.target))).errorCode);
                    });
                    request.onblocked = (/**
                     * @param {?} event
                     * @return {?}
                     */
                    function (event) {
                        errorResponse_1(event);
                    });
                    request.onerror = (/**
                     * @param {?} event
                     * @return {?}
                     */
                    function (event) {
                        errorResponse_1(event);
                    });
                    request.onsuccess = (/**
                     * @return {?}
                     */
                    function () {
                        console.log('[In-Memory]', 'Deleted OK.');
                        // alert('*** NOTE : Requires page refresh to see the DB removed from the Resources IndexedDB tab in Chrome.');
                        resolve(true);
                    });
                }
            }));
            return result$;
        };
        /**
         * @return {?}
         */
        InMemoryDataService.prototype.createDatabase = /**
         * @return {?}
         */
        function () {
            var _this = this;
            /** @type {?} */
            var self = this;
            /** @type {?} */
            var result$ = new Promise((/**
             * @param {?} resolve
             * @param {?} reject
             * @return {?}
             */
            function (resolve, reject) {
                // Para testes e2e usa o banco de dados em memória mesmo
                if (_this.config.memoryOnly) {
                    console.log('[In-Memory]', 'Database e2e created!');
                    resolve(true);
                }
                else {
                    /** @type {?} */
                    var request_1 = window.indexedDB.open(_this.config.databaseName, 1);
                    request_1.onsuccess = (/**
                     * @param {?} event
                     * @return {?}
                     */
                    function (event) {
                        self.db = request_1.result;
                        console.log('[In-Memory]', 'Database created!');
                    });
                    request_1.onerror = (/**
                     * @param {?} event
                     * @return {?}
                     */
                    function (event) {
                        console.log('[In-Memory]', 'Database error: ', ((/** @type {?} */ (event.target))).errorCode);
                        reject(((/** @type {?} */ (event.target))).errorCode);
                    });
                    request_1.onupgradeneeded = (/**
                     * @param {?} event
                     * @return {?}
                     */
                    function (event) {
                        self.db = request_1.result;
                        console.log('[In-Memory]', 'Database upgrade nedded!');
                        resolve(true);
                    });
                }
            }));
            return result$;
        };
        /**
         * @param {?} dataServiceFn
         * @return {?}
         */
        InMemoryDataService.prototype.createObjectStore = /**
         * @param {?} dataServiceFn
         * @return {?}
         */
        function (dataServiceFn) {
            var _this = this;
            /** @type {?} */
            var self = this;
            /** @type {?} */
            var result$ = new Promise((/**
             * @param {?} resolve
             * @param {?} reject
             * @return {?}
             */
            function (resolve, reject) {
                // Para testes e2e usa o banco de dados em memória mesmo
                if (_this.config.memoryOnly) {
                    dataServiceFn.forEach((/**
                     * @param {?} loadFn
                     * @param {?} name
                     * @return {?}
                     */
                    function (loadFn, name) {
                        console.log('[In-Memory]', "Added: " + name + ".");
                        _this.dbe2e.set(name, []);
                        if (loadFn && loadFn instanceof Function) {
                            loadFn.call(null, self);
                        }
                    }));
                    resolve(true);
                }
                else {
                    /** @type {?} */
                    var objectStore_1;
                    dataServiceFn.forEach((/**
                     * @param {?} loadFn
                     * @param {?} name
                     * @return {?}
                     */
                    function (loadFn, name) {
                        console.log('[In-Memory]', name + " => Mock defined");
                        objectStore_1 = _this.db.createObjectStore(name, { keyPath: 'id' });
                        if (loadFn && loadFn instanceof Function) {
                            self.loadsFn.push(loadFn);
                        }
                    }));
                    objectStore_1.transaction.oncomplete = (/**
                     * @param {?} event
                     * @return {?}
                     */
                    function (event) {
                        self.loadsFn.forEach((/**
                         * @param {?} fn
                         * @return {?}
                         */
                        function (fn) {
                            fn.call(null, self);
                        }));
                        resolve(true);
                    });
                    objectStore_1.transaction.onerror = (/**
                     * @param {?} event
                     * @return {?}
                     */
                    function (event) {
                        reject(event);
                    });
                }
            }));
            return result$;
        };
        /**
         * @param {?} collectionName
         * @param {?} data
         * @return {?}
         */
        InMemoryDataService.prototype.storeData = /**
         * @param {?} collectionName
         * @param {?} data
         * @return {?}
         */
        function (collectionName, data) {
            var _this = this;
            /** @type {?} */
            var self = this;
            /** @type {?} */
            var result$ = new Promise((/**
             * @param {?} resolve
             * @param {?} reject
             * @return {?}
             */
            function (resolve, reject) {
                if (!data['id']) {
                    data['id'] = uuid.v4();
                }
                // Para testes e2e usa o banco de dados em memória mesmo
                if (_this.config.memoryOnly) {
                    /** @type {?} */
                    var objectStore = self.dbe2e.get(collectionName);
                    objectStore.push(data);
                    resolve(data['id']);
                }
                else {
                    /** @type {?} */
                    var objectStore = self.db.transaction(collectionName, 'readwrite').objectStore(collectionName);
                    /** @type {?} */
                    var request_2 = objectStore.add(data);
                    request_2.onsuccess = (/**
                     * @param {?} event
                     * @return {?}
                     */
                    function (event) {
                        resolve((request_2.result !== undefined) ? data['id'] : null);
                    });
                    request_2.onerror = (/**
                     * @param {?} event
                     * @return {?}
                     */
                    function (event) {
                        reject(event);
                    });
                }
            }));
            return result$;
        };
        /**
         * @param {?} collectionName
         * @return {?}
         */
        InMemoryDataService.prototype.clearData = /**
         * @param {?} collectionName
         * @return {?}
         */
        function (collectionName) {
            var _this = this;
            /** @type {?} */
            var self = this;
            /** @type {?} */
            var result$ = new Promise((/**
             * @param {?} resolve
             * @param {?} reject
             * @return {?}
             */
            function (resolve, reject) {
                // Para testes e2e usa o banco de dados em memória mesmo
                if (_this.config.memoryOnly) {
                    self.dbe2e.set(collectionName, []);
                    resolve(true);
                }
                else {
                    /** @type {?} */
                    var objectStore = self.db.transaction(collectionName, 'readwrite').objectStore(collectionName);
                    /** @type {?} */
                    var request = objectStore.clear();
                    request.onsuccess = (/**
                     * @param {?} event
                     * @return {?}
                     */
                    function (event) {
                        resolve(true);
                    });
                    request.onerror = (/**
                     * @param {?} event
                     * @return {?}
                     */
                    function (event) {
                        reject(event);
                    });
                }
            }));
            return result$;
        };
        /**
         * @param {?} requestInterceptor
         * @return {?}
         */
        InMemoryDataService.prototype.addRequestInterceptor = /**
         * @param {?} requestInterceptor
         * @return {?}
         */
        function (requestInterceptor) {
            if (!requestInterceptor.method) {
                requestInterceptor['method'] = 'GET';
            }
            this.requestInterceptors.push(requestInterceptor);
        };
        /**
         * @param {?} key
         * @param {?} value
         * @return {?}
         */
        InMemoryDataService.prototype.addReplaceUrl = /**
         * @param {?} key
         * @param {?} value
         * @return {?}
         */
        function (key, value) {
            this.replaceMap.set(key, value);
        };
        /**
         * @param {?} collectionName
         * @param {?} fields
         * @return {?}
         */
        InMemoryDataService.prototype.addSearchTermMap = /**
         * @param {?} collectionName
         * @param {?} fields
         * @return {?}
         */
        function (collectionName, fields) {
            this.searchTermMap.set(collectionName, fields);
        };
        /**
         * @param {?} collectionName
         * @param {?} transformfn
         * @return {?}
         */
        InMemoryDataService.prototype.addTransformGetMap = /**
         * @param {?} collectionName
         * @param {?} transformfn
         * @return {?}
         */
        function (collectionName, transformfn) {
            this.transformGetMap.set(collectionName, transformfn);
        };
        /**
         * @param {?} collectionName
         * @param {?} transformfn
         * @return {?}
         */
        InMemoryDataService.prototype.addTransformPostMap = /**
         * @param {?} collectionName
         * @param {?} transformfn
         * @return {?}
         */
        function (collectionName, transformfn) {
            this.transformPostMap.set(collectionName, transformfn);
        };
        /**
         * @param {?} collectionName
         * @param {?} transformfn
         * @return {?}
         */
        InMemoryDataService.prototype.addTransformPutMap = /**
         * @param {?} collectionName
         * @param {?} transformfn
         * @return {?}
         */
        function (collectionName, transformfn) {
            this.transformPutMap.set(collectionName, transformfn);
        };
        /**
         * @param {?} collectionName
         * @param {?} field
         * @param {?} filterfn
         * @return {?}
         */
        InMemoryDataService.prototype.addFieldFilterMap = /**
         * @param {?} collectionName
         * @param {?} field
         * @param {?} filterfn
         * @return {?}
         */
        function (collectionName, field, filterfn) {
            /** @type {?} */
            var fieldsFilterMap = this.fieldsFilterMap.get(collectionName);
            if (fieldsFilterMap !== undefined) {
                fieldsFilterMap.set(field, filterfn);
            }
            else {
                fieldsFilterMap = new Map();
                fieldsFilterMap.set(field, filterfn);
                this.fieldsFilterMap.set(collectionName, fieldsFilterMap);
            }
        };
        /**
         * @param {?} value
         * @return {?}
         */
        InMemoryDataService.prototype.addRequestInterceptorByValue = /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            /** @type {?} */
            var obj;
            /** @type {?} */
            var response;
            if (typeof value === 'string') {
                try {
                    obj = JSON.parse(value);
                }
                catch (error) {
                    console.error('[In-Memory]', 'O valor informado não é possível de ser interpretado como uma interface IRequestInterceptor');
                    return;
                }
            }
            else {
                obj = value;
            }
            if (obj && obj.path && typeof obj.path === 'string' && obj.response) {
                /** @type {?} */
                var path = '/' + obj.path.replace(/^\//, '');
                /** @type {?} */
                var url = window.location.origin + path;
                /** @type {?} */
                var status_1 = (obj.response.status && typeof obj.response.status === 'number') ? obj.response.status :
                    (obj.response.statusCode && typeof obj.response.statusCode === 'number') ? obj.response.statusCode :
                        (obj.response.error) ? 400 : 200;
                if (typeof obj.response === 'string') {
                    response = new http.HttpResponse({
                        body: obj.response,
                        url: url,
                        headers: new http.HttpHeaders({ 'Content-Type': 'text/html; charset=utf-8' }),
                        status: status_1,
                        statusText: angularInMemoryWebApi.getStatusText(status_1)
                    });
                }
                else if (obj.response.error) {
                    response = new http.HttpErrorResponse({
                        error: obj.response.error,
                        url: url,
                        headers: new http.HttpHeaders({ 'Content-Type': 'application/json' }),
                        status: status_1,
                        statusText: angularInMemoryWebApi.getStatusText(status_1)
                    });
                }
                else {
                    response = new http.HttpResponse({
                        body: (obj.response.body) ? obj.response.body : obj.response,
                        url: url,
                        headers: new http.HttpHeaders({ 'Content-Type': 'application/json' }),
                        status: status_1,
                        statusText: angularInMemoryWebApi.getStatusText(status_1)
                    });
                }
            }
            else {
                console.error('[In-Memory]', 'O valor informado não é possível de ser interpretado como uma interface IRequestInterceptor');
                return;
            }
            /** @type {?} */
            var requestInterceptor = {
                method: obj.method ? obj.method : 'GET',
                path: obj.path,
                response: response,
            };
            /** @type {?} */
            var params;
            /** @type {?} */
            var query = obj.query ? obj.query :
                (obj.queryStringParameters ? obj.queryStringParameters : undefined);
            if (query) {
                if (typeof query === 'string') {
                    params = new http.HttpParams({ fromString: query });
                }
                else {
                    params = new http.HttpParams({ fromObject: query });
                }
                if (params && params.keys.length > 0) {
                    requestInterceptor['query'] = params;
                }
            }
            this.requestInterceptors.push(requestInterceptor);
        };
        /**
         * @private
         * @param {?} collectionName
         * @param {?} field
         * @return {?}
         */
        InMemoryDataService.prototype.getFieldFilterMap = /**
         * @private
         * @param {?} collectionName
         * @param {?} field
         * @return {?}
         */
        function (collectionName, field) {
            /** @type {?} */
            var fieldsFilterMap = this.fieldsFilterMap.get(collectionName);
            if (fieldsFilterMap !== undefined) {
                return fieldsFilterMap.get(field);
            }
            else {
                return undefined;
            }
        };
        /**
         * @private
         * @param {?} data
         * @return {?}
         */
        InMemoryDataService.prototype.clone = /**
         * @private
         * @param {?} data
         * @return {?}
         */
        function (data) {
            return JSON.parse(JSON.stringify(data));
        };
        /**
         * @private
         * @param {?} url
         * @param {?} status
         * @param {?} message
         * @param {?=} detailedMessage
         * @return {?}
         */
        InMemoryDataService.prototype.createErrorResponseOptions = /**
         * @private
         * @param {?} url
         * @param {?} status
         * @param {?} message
         * @param {?=} detailedMessage
         * @return {?}
         */
        function (url, status, message, detailedMessage) {
            return new http.HttpErrorResponse({
                error: { message: message, detailedMessage: detailedMessage },
                url: url,
                headers: new http.HttpHeaders({ 'Content-Type': 'application/json' }),
                status: status,
                statusText: angularInMemoryWebApi.getStatusText(status)
            });
        };
        /**
         * @private
         * @param {?} url
         * @param {?} status
         * @param {?=} body
         * @return {?}
         */
        InMemoryDataService.prototype.createResponseOptions = /**
         * @private
         * @param {?} url
         * @param {?} status
         * @param {?=} body
         * @return {?}
         */
        function (url, status, body) {
            return new http.HttpResponse({
                body: body,
                url: url,
                headers: new http.HttpHeaders({ 'Content-Type': 'application/json' }),
                status: status,
                statusText: angularInMemoryWebApi.getStatusText(status)
            });
        };
        /**
         * @private
         * @param {?} item
         * @param {?} conditions
         * @param {?} useFilterOr
         * @return {?}
         */
        InMemoryDataService.prototype.filterItem = /**
         * @private
         * @param {?} item
         * @param {?} conditions
         * @param {?} useFilterOr
         * @return {?}
         */
        function (item, conditions, useFilterOr) {
            if (conditions === undefined) {
                return true;
            }
            return useFilterOr ? this.filterItemOr(item, conditions) : this.filterItemAnd(item, conditions);
        };
        /**
         * @private
         * @param {?} item
         * @param {?} conditions
         * @return {?}
         */
        InMemoryDataService.prototype.filterItemAnd = /**
         * @private
         * @param {?} item
         * @param {?} conditions
         * @return {?}
         */
        function (item, conditions) {
            /** @type {?} */
            var ok = true;
            /** @type {?} */
            var i = conditions.length;
            /** @type {?} */
            var cond;
            while (ok && i) {
                i -= 1;
                cond = conditions[i];
                if (cond.fn) {
                    ok = cond.fn.call(this, item);
                }
                else {
                    ok = cond.rx.test(item[cond.name]);
                }
            }
            return ok;
        };
        /**
         * @private
         * @param {?} item
         * @param {?} conditions
         * @return {?}
         */
        InMemoryDataService.prototype.filterItemOr = /**
         * @private
         * @param {?} item
         * @param {?} conditions
         * @return {?}
         */
        function (item, conditions) {
            /** @type {?} */
            var ok = false;
            /** @type {?} */
            var okUnidade = true;
            /** @type {?} */
            var i = conditions.length;
            /** @type {?} */
            var cond;
            while (okUnidade && !ok && i) {
                i -= 1;
                cond = conditions[i];
                if (cond.name === 'unidadeId') {
                    okUnidade = cond.fn.call(this, item);
                }
                else {
                    if (cond.fn) {
                        ok = cond.fn.call(this, item);
                    }
                    else {
                        ok = cond.rx.test(item[cond.name]);
                    }
                }
            }
            return ok && okUnidade;
        };
        /**
         * @private
         * @param {?} value
         * @param {?} filterFn
         * @return {?}
         */
        InMemoryDataService.prototype.createFilterFn = /**
         * @private
         * @param {?} value
         * @param {?} filterFn
         * @return {?}
         */
        function (value, filterFn) {
            var _this = this;
            return (/**
             * @param {?} item
             * @return {?}
             */
            function (item) {
                return filterFn.call(_this, value, item);
            });
        };
        /**
         * @private
         * @param {?} id
         * @return {?}
         */
        InMemoryDataService.prototype.createFilterUnidadeFn = /**
         * @private
         * @param {?} id
         * @return {?}
         */
        function (id) {
            return (/**
             * @param {?} item
             * @return {?}
             */
            function (item) {
                return item['unidadeId'] === id;
            });
        };
        /**
         * @private
         * @param {?} field
         * @param {?} value
         * @return {?}
         */
        InMemoryDataService.prototype.createFilterArrayFn = /**
         * @private
         * @param {?} field
         * @param {?} value
         * @return {?}
         */
        function (field, value) {
            return (/**
             * @param {?} item
             * @return {?}
             */
            function (item) {
                return value.includes(item[field]);
            });
        };
        /**
         * @private
         * @param {?} response$
         * @param {?} delay
         * @return {?}
         */
        InMemoryDataService.prototype.addDelay = /**
         * @private
         * @param {?} response$
         * @param {?} delay
         * @return {?}
         */
        function (response$, delay) {
            return delay === 0 ? response$ : delayResponse.delayResponse(response$, (Math.floor((Math.random() * delay) + 1)) || 500);
        };
        /**
         * @private
         * @param {?} collectionName
         * @param {?} query
         * @param {?} caseSensitive
         * @return {?}
         */
        InMemoryDataService.prototype.getQueryParams = /**
         * @private
         * @param {?} collectionName
         * @param {?} query
         * @param {?} caseSensitive
         * @return {?}
         */
        function (collectionName, query, caseSensitive) {
            var _this = this;
            /** @type {?} */
            var queryParams = { count: 0 };
            query.forEach((/**
             * @param {?} value
             * @param {?} name
             * @return {?}
             */
            function (value, name) {
                var _a;
                if (name === 'page') {
                    queryParams['page'] = parseInt(value[0], 10);
                }
                else if (name === 'pageSize') {
                    queryParams['pageSize'] = parseInt(value[0], 10);
                }
                else if (name === 'unidadeId') {
                    /** @type {?} */
                    var condition = { name: name };
                    if (queryParams['conditions'] === undefined) {
                        queryParams['conditions'] = [];
                    }
                    condition['fn'] = _this.createFilterUnidadeFn(value[0]);
                    queryParams.conditions.push(condition);
                }
                else if (name === 'searchTerm' && value[0]) {
                    queryParams['useFilterOr'] = true;
                    /** @type {?} */
                    var fields = _this.searchTermMap.get(collectionName);
                    if (fields !== undefined) {
                        if (queryParams['conditions'] === undefined) {
                            queryParams['conditions'] = [];
                        }
                        (_a = queryParams.conditions).push.apply(_a, __spread(fields.map((/**
                         * @param {?} field
                         * @return {?}
                         */
                        function (field) {
                            return { name: field, rx: new RegExp(decodeURI(value[0]), caseSensitive) };
                        }))));
                    }
                }
                else if (name !== 'order' && name !== 'fields' && name !== '$filter') {
                    if (queryParams['conditions'] === undefined) {
                        queryParams['conditions'] = [];
                    }
                    /** @type {?} */
                    var condition = { name: name };
                    /** @type {?} */
                    var filterFn = _this.getFieldFilterMap(collectionName, name);
                    if (filterFn !== undefined && filterFn instanceof Function) {
                        condition['fn'] = _this.createFilterFn(value.length > 1 ? value : decodeURI(value[0]), filterFn);
                    }
                    else if (value.length > 1) {
                        condition['fn'] = _this.createFilterArrayFn(name, value);
                    }
                    else {
                        condition['rx'] = new RegExp(decodeURI(value[0]), caseSensitive);
                    }
                    queryParams.conditions.push(condition);
                }
            }));
            return queryParams;
        };
        /**
         * @private
         * @param {?} cursor
         * @param {?} queryResults
         * @param {?} queryParams
         * @param {?} transformfn
         * @return {?}
         */
        InMemoryDataService.prototype.getAllItems = /**
         * @private
         * @param {?} cursor
         * @param {?} queryResults
         * @param {?} queryParams
         * @param {?} transformfn
         * @return {?}
         */
        function (cursor, queryResults, queryParams, transformfn) {
            /** @type {?} */
            var retorna = false;
            if (cursor) {
                /** @type {?} */
                var item = cursor.value;
                if (this.filterItem(item, queryParams.conditions, queryParams.useFilterOr)) {
                    if (queryParams.page && queryParams.pageSize) {
                        if (queryParams.count < ((queryParams.page - 1) * queryParams.pageSize)) {
                            queryParams.count++;
                            cursor.continue();
                        }
                        else if (queryParams.count < (queryParams.page * queryParams.pageSize)) {
                            if (transformfn !== undefined) {
                                item = transformfn.call(this, item, this);
                            }
                            queryResults.items.push(item);
                            queryResults.hasNext = true;
                            queryParams.count++;
                            cursor.continue();
                        }
                        else {
                            retorna = true;
                        }
                    }
                    else {
                        if (transformfn !== undefined) {
                            item = transformfn.call(this, item, this);
                        }
                        queryResults.items.push(item);
                        queryResults.hasNext = true;
                        cursor.continue();
                    }
                }
                else {
                    cursor.continue();
                }
            }
            else {
                queryResults.hasNext = false;
                retorna = true;
            }
            return retorna;
        };
        /**
         * @private
         * @template T
         * @param {?} collection
         * @param {?} id
         * @return {?}
         */
        InMemoryDataService.prototype.findById = /**
         * @private
         * @template T
         * @param {?} collection
         * @param {?} id
         * @return {?}
         */
        function (collection, id) {
            return collection.find((/**
             * @param {?} item
             * @return {?}
             */
            function (item) { return item.id === id; }));
        };
        /**
         * @private
         * @param {?} collection
         * @param {?} id
         * @return {?}
         */
        InMemoryDataService.prototype.indexOf = /**
         * @private
         * @param {?} collection
         * @param {?} id
         * @return {?}
         */
        function (collection, id) {
            return collection.findIndex((/**
             * @param {?} item
             * @return {?}
             */
            function (item) { return item.id === id; }));
        };
        /**
         * @param {?} collectionName
         * @param {?} id
         * @return {?}
         */
        InMemoryDataService.prototype.getInstance$ = /**
         * @param {?} collectionName
         * @param {?} id
         * @return {?}
         */
        function (collectionName, id) {
            var _this = this;
            return new rxjs.Observable((/**
             * @param {?} observer
             * @return {?}
             */
            function (observer) {
                /** @type {?} */
                var self = _this;
                // Para testes e2e usa o banco de dados em memória mesmo
                if (_this.config.memoryOnly) {
                    /** @type {?} */
                    var objectStore = _this.dbe2e.get(collectionName);
                    if (id !== undefined && id !== '') {
                        observer.next(_this.findById(objectStore, id));
                        observer.complete();
                    }
                    else {
                        observer.error('Não foi passado o id');
                    }
                }
                else {
                    /** @type {?} */
                    var request_3;
                    /** @type {?} */
                    var objectStore = self.db.transaction(collectionName, 'readwrite').objectStore(collectionName);
                    if (id !== undefined && id !== '') {
                        request_3 = objectStore.get(id);
                        request_3.onsuccess = (/**
                         * @param {?} event
                         * @return {?}
                         */
                        function (event) {
                            observer.next(request_3.result);
                            observer.complete();
                        });
                        request_3.onerror = (/**
                         * @param {?} event
                         * @return {?}
                         */
                        function (event) {
                            observer.error(((/** @type {?} */ (event.target))).error);
                        });
                    }
                    else {
                        observer.error('Não foi passado o id');
                    }
                }
            }));
        };
        /**
         * @param {?} collectionName
         * @param {?} id
         * @param {?} query
         * @param {?} url
         * @param {?=} caseSensitiveSearch
         * @return {?}
         */
        InMemoryDataService.prototype.get$ = /**
         * @param {?} collectionName
         * @param {?} id
         * @param {?} query
         * @param {?} url
         * @param {?=} caseSensitiveSearch
         * @return {?}
         */
        function (collectionName, id, query, url, caseSensitiveSearch) {
            var _this = this;
            return new rxjs.Observable((/**
             * @param {?} observer
             * @return {?}
             */
            function (observer) {
                /** @type {?} */
                var self = _this;
                /** @type {?} */
                var response;
                /** @type {?} */
                var request;
                /** @type {?} */
                var isCursor = false;
                /** @type {?} */
                var queryParams = { count: 0 };
                /** @type {?} */
                var queryResults = { hasNext: false, items: [] };
                /** @type {?} */
                var transformfn = self.transformGetMap.get(collectionName);
                // Para testes e2e usa o banco de dados em memória mesmo
                if (_this.config.memoryOnly) {
                    /** @type {?} */
                    var objectStore = _this.dbe2e.get(collectionName);
                    if (id !== undefined && id !== '') {
                        /** @type {?} */
                        var item = _this.findById(objectStore, id);
                        if (item && transformfn !== undefined) {
                            item = transformfn.call(_this, item, _this);
                        }
                        response = self.createResponseOptions(url, item ? angularInMemoryWebApi.STATUS.OK : angularInMemoryWebApi.STATUS.NOT_FOUND, item);
                        observer.next(response);
                        observer.complete();
                    }
                    else {
                        if (query) {
                            queryParams = self.getQueryParams(collectionName, query, (caseSensitiveSearch ? caseSensitiveSearch : 'i'));
                        }
                        /** @type {?} */
                        var cursor = {
                            index: 0,
                            value: null,
                            continue: (/**
                             * @return {?}
                             */
                            function () { })
                        };
                        while (cursor.index <= objectStore.length) {
                            cursor.value = (cursor.index < objectStore.length) ? objectStore[cursor.index++] : null;
                            if (self.getAllItems((cursor.value ? cursor : null), queryResults, queryParams, transformfn)) {
                                response = self.createResponseOptions(url, angularInMemoryWebApi.STATUS.OK, queryResults);
                                observer.next(response);
                                observer.complete();
                                break;
                            }
                        }
                    }
                }
                else {
                    /** @type {?} */
                    var objectStore = self.db.transaction(collectionName, 'readwrite').objectStore(collectionName);
                    if (id !== undefined && id !== '') {
                        request = objectStore.get(id);
                    }
                    else {
                        request = objectStore.openCursor();
                        isCursor = true;
                        if (query) {
                            queryParams = self.getQueryParams(collectionName, query, (caseSensitiveSearch ? caseSensitiveSearch : 'i'));
                        }
                    }
                    request.onsuccess = (/**
                     * @param {?} event
                     * @return {?}
                     */
                    function (event) {
                        if (!isCursor) {
                            /** @type {?} */
                            var item = request.result;
                            if (item && transformfn !== undefined) {
                                item = transformfn.call(_this, item, _this);
                            }
                            response = self.createResponseOptions(url, item ? angularInMemoryWebApi.STATUS.OK : angularInMemoryWebApi.STATUS.NOT_FOUND, item);
                            observer.next(response);
                            observer.complete();
                        }
                        else {
                            if (self.getAllItems(((/** @type {?} */ (event.target))).result, queryResults, queryParams, transformfn)) {
                                response = self.createResponseOptions(url, angularInMemoryWebApi.STATUS.OK, queryResults);
                                observer.next(response);
                                observer.complete();
                            }
                        }
                    });
                    request.onerror = (/**
                     * @param {?} event
                     * @return {?}
                     */
                    function (event) {
                        response = self.createErrorResponseOptions(url, angularInMemoryWebApi.STATUS.INTERNAL_SERVER_ERROR, ((/** @type {?} */ (event.target))).error);
                        observer.error(response);
                    });
                }
            }));
        };
        /**
         * @param {?} reqInfo
         * @return {?}
         */
        InMemoryDataService.prototype.get = /**
         * @param {?} reqInfo
         * @return {?}
         */
        function (reqInfo) {
            /** @type {?} */
            var response$;
            // Caso tenha um interceptador, retorna a resposta do mesmo
            response$ = this.processInterceptResponse(reqInfo, { id: reqInfo.id });
            if (response$) {
                return this.addDelay(response$, reqInfo.utils.getConfig().delay);
            }
            // Caso não tenha a collection, repassa a requisição para o backend verdadeiro
            // Para testes e2e usa o banco de dados em memória mesmo
            if (this.config.memoryOnly) {
                if (!this.dbe2e.has(reqInfo.collectionName)) {
                    return undefined;
                }
            }
            else {
                if (!this.db.objectStoreNames.contains(reqInfo.collectionName)) {
                    return undefined;
                }
            }
            response$ = this.get$(reqInfo.collectionName, reqInfo.id, reqInfo.query, reqInfo.url, reqInfo.utils.getConfig().caseSensitiveSearch ? undefined : 'i');
            return this.addDelay(response$, reqInfo.utils.getConfig().delay);
        };
        /**
         * @param {?} collectionName
         * @param {?} id
         * @param {?} item
         * @param {?} url
         * @return {?}
         */
        InMemoryDataService.prototype.put$ = /**
         * @param {?} collectionName
         * @param {?} id
         * @param {?} item
         * @param {?} url
         * @return {?}
         */
        function (collectionName, id, item, url) {
            var _this = this;
            return new rxjs.Observable((/**
             * @param {?} observer
             * @return {?}
             */
            function (observer) {
                /** @type {?} */
                var self = _this;
                /** @type {?} */
                var response;
                /** @type {?} */
                var transformfn = _this.transformPutMap.get(collectionName);
                // Para testes e2e usa o banco de dados em memória mesmo
                if (_this.config.memoryOnly) {
                    /** @type {?} */
                    var objectStore = _this.dbe2e.get(collectionName);
                    /** @type {?} */
                    var existingIx = _this.indexOf(objectStore, id);
                    if (existingIx >= 0) {
                        if (transformfn !== undefined) {
                            item = transformfn.call(_this, objectStore[existingIx], item);
                        }
                        item = Object.assign({}, objectStore[existingIx], item);
                        objectStore[existingIx] = item;
                        response = self.createResponseOptions(url, angularInMemoryWebApi.STATUS.NO_CONTENT);
                        observer.next(response);
                        observer.complete();
                    }
                    else {
                        response = self.createErrorResponseOptions(url, angularInMemoryWebApi.STATUS.NOT_FOUND, '\'' + collectionName + '\' item with id=\'' + id +
                            ' not found and may not be created with PUT; use POST instead.');
                        observer.error(response);
                    }
                }
                else {
                    /** @type {?} */
                    var objectStore_2 = self.db.transaction(collectionName, 'readwrite').objectStore(collectionName);
                    /** @type {?} */
                    var request_4 = objectStore_2.get(id);
                    request_4.onsuccess = (/**
                     * @param {?} event
                     * @return {?}
                     */
                    function (event) {
                        if (request_4.result) {
                            if (transformfn !== undefined) {
                                item = transformfn.call(_this, request_4.result, item);
                            }
                            item = Object.assign({}, request_4.result, item);
                            /** @type {?} */
                            var requestUpdate = objectStore_2.put(item);
                            requestUpdate.onsuccess = (/**
                             * @return {?}
                             */
                            function () {
                                response = self.createResponseOptions(url, angularInMemoryWebApi.STATUS.NO_CONTENT);
                                observer.next(response);
                                observer.complete();
                            });
                            requestUpdate.onerror = (/**
                             * @param {?} errorEvent
                             * @return {?}
                             */
                            function (errorEvent) {
                                response = self.createErrorResponseOptions(url, angularInMemoryWebApi.STATUS.INTERNAL_SERVER_ERROR, 'Erro ao atualizar \'' + collectionName + '\' pelo id: \'' +
                                    id + '\'', ((/** @type {?} */ (errorEvent.target))).error);
                                observer.error(response);
                            });
                        }
                        else {
                            response = self.createErrorResponseOptions(url, angularInMemoryWebApi.STATUS.NOT_FOUND, '\'' + collectionName + '\' item with id=\'' + id +
                                ' not found and may not be created with PUT; use POST instead.');
                            observer.error(response);
                        }
                    });
                    request_4.onerror = (/**
                     * @param {?} event
                     * @return {?}
                     */
                    function (event) {
                        response = self.createErrorResponseOptions(url, angularInMemoryWebApi.STATUS.INTERNAL_SERVER_ERROR, 'Erro ao buscar \'' + collectionName + '\' pelo id: \'' + id + '\'', ((/** @type {?} */ (event.target))).error);
                        observer.error(response);
                    });
                }
            }));
        };
        /**
         * @param {?} reqInfo
         * @return {?}
         */
        InMemoryDataService.prototype.put = /**
         * @param {?} reqInfo
         * @return {?}
         */
        function (reqInfo) {
            /** @type {?} */
            var response$;
            /** @type {?} */
            var item = this.clone(reqInfo.utils.getJsonBody(reqInfo.req)) || { id: reqInfo.id };
            if (!item.id) {
                item['id'] = reqInfo.id;
            }
            // Caso tenha um interceptador, retorna a resposta do mesmo
            response$ = this.processInterceptResponse(reqInfo, item);
            if (response$) {
                return this.addDelay(response$, reqInfo.utils.getConfig().delay);
            }
            // Caso não tenha a collection, repassa a requisição para o backend verdadeiro
            // Para testes e2e usa o banco de dados em memória mesmo
            if (this.config.memoryOnly) {
                if (!this.dbe2e.has(reqInfo.collectionName)) {
                    return undefined;
                }
            }
            else {
                if (!this.db.objectStoreNames.contains(reqInfo.collectionName)) {
                    return undefined;
                }
            }
            response$ = this.put$(reqInfo.collectionName, reqInfo.id, item, reqInfo.url);
            return this.addDelay(response$, reqInfo.utils.getConfig().delay);
        };
        /**
         * @param {?} collectionName
         * @param {?} item
         * @param {?} url
         * @return {?}
         */
        InMemoryDataService.prototype.post$ = /**
         * @param {?} collectionName
         * @param {?} item
         * @param {?} url
         * @return {?}
         */
        function (collectionName, item, url) {
            var _this = this;
            return new rxjs.Observable((/**
             * @param {?} observer
             * @return {?}
             */
            function (observer) {
                /** @type {?} */
                var self = _this;
                /** @type {?} */
                var response;
                if (!item.id) {
                    item['id'] = uuid.v4();
                }
                /** @type {?} */
                var transformfn = _this.transformPostMap.get(collectionName);
                if (transformfn !== undefined) {
                    item = transformfn.call(_this, item, _this);
                }
                // Para testes e2e usa o banco de dados em memória mesmo
                if (_this.config.memoryOnly) {
                    /** @type {?} */
                    var objectStore = _this.dbe2e.get(collectionName);
                    objectStore.push(item);
                    response = self.createResponseOptions(url, angularInMemoryWebApi.STATUS.CREATED, { id: item.id });
                    response = response.clone({ headers: response.headers.append('Location', url + '/' + item.id) });
                    observer.next(response);
                    observer.complete();
                }
                else {
                    /** @type {?} */
                    var objectStore = self.db.transaction(collectionName, 'readwrite').objectStore(collectionName);
                    /** @type {?} */
                    var request_5 = objectStore.add(item);
                    request_5.onsuccess = (/**
                     * @param {?} event
                     * @return {?}
                     */
                    function (event) {
                        if (request_5.result) {
                            response = self.createResponseOptions(url, angularInMemoryWebApi.STATUS.CREATED, { id: item.id });
                            response = response.clone({ headers: response.headers.append('Location', url + '/' + item.id) });
                            observer.next(response);
                            observer.complete();
                        }
                    });
                    request_5.onerror = (/**
                     * @param {?} event
                     * @return {?}
                     */
                    function (event) {
                        response = self.createErrorResponseOptions(url, angularInMemoryWebApi.STATUS.INTERNAL_SERVER_ERROR, 'Erro ao incluir \'' + collectionName + '\' pelo id: \'' + item.id + '\'', ((/** @type {?} */ (event.target))).error);
                        observer.error(response);
                    });
                }
            }));
        };
        /**
         * @param {?} reqInfo
         * @return {?}
         */
        InMemoryDataService.prototype.post = /**
         * @param {?} reqInfo
         * @return {?}
         */
        function (reqInfo) {
            /** @type {?} */
            var response$;
            /** @type {?} */
            var item = this.clone(reqInfo.utils.getJsonBody(reqInfo.req)) || { id: reqInfo.id };
            if (!item.hasOwnProperty('id')) {
                item['id'] = reqInfo.id;
            }
            // Caso tenha um interceptador, retorna a resposta do mesmo
            response$ = this.processInterceptResponse(reqInfo, item);
            if (response$) {
                return this.addDelay(response$, reqInfo.utils.getConfig().delay);
            }
            // Caso não tenha a collection, repassa a requisição para o backend verdadeiro
            // Para testes e2e usa o banco de dados em memória mesmo
            if (this.config.memoryOnly) {
                if (!this.dbe2e.has(reqInfo.collectionName)) {
                    return undefined;
                }
            }
            else {
                if (!this.db.objectStoreNames.contains(reqInfo.collectionName)) {
                    return undefined;
                }
            }
            response$ = this.post$(reqInfo.collectionName, item, reqInfo.url);
            return this.addDelay(response$, reqInfo.utils.getConfig().delay);
        };
        /**
         * @param {?} collectionName
         * @param {?} id
         * @param {?} url
         * @return {?}
         */
        InMemoryDataService.prototype.delete$ = /**
         * @param {?} collectionName
         * @param {?} id
         * @param {?} url
         * @return {?}
         */
        function (collectionName, id, url) {
            var _this = this;
            return new rxjs.Observable((/**
             * @param {?} observer
             * @return {?}
             */
            function (observer) {
                /** @type {?} */
                var self = _this;
                // Para testes e2e usa o banco de dados em memória mesmo
                if (_this.config.memoryOnly) {
                    /** @type {?} */
                    var objectStore = _this.dbe2e.get(collectionName);
                    if (_this.removeById(objectStore, id)) {
                        /** @type {?} */
                        var response = self.createResponseOptions(url, angularInMemoryWebApi.STATUS.NO_CONTENT, true);
                        observer.next(response);
                        observer.complete();
                    }
                    else {
                        /** @type {?} */
                        var response = self.createErrorResponseOptions(url, angularInMemoryWebApi.STATUS.NOT_FOUND, 'Erro ao buscar \'' + collectionName + '\' pelo id: \'' + id + '\'', 'Id não encontrado.');
                        observer.error(response);
                    }
                }
                else {
                    /** @type {?} */
                    var objectStore = self.db.transaction(collectionName, 'readwrite').objectStore(collectionName);
                    /** @type {?} */
                    var request = objectStore.delete(id);
                    request.onsuccess = (/**
                     * @param {?} event
                     * @return {?}
                     */
                    function (event) {
                        /** @type {?} */
                        var response = self.createResponseOptions(url, angularInMemoryWebApi.STATUS.NO_CONTENT, true);
                        observer.next(response);
                        observer.complete();
                    });
                    request.onerror = (/**
                     * @param {?} event
                     * @return {?}
                     */
                    function (event) {
                        /** @type {?} */
                        var response = self.createErrorResponseOptions(url, angularInMemoryWebApi.STATUS.INTERNAL_SERVER_ERROR, 'Erro ao buscar \'' + collectionName + '\' pelo id: \'' + id + '\'', ((/** @type {?} */ (event.target))).error);
                        observer.error(response);
                    });
                }
            }));
        };
        /**
         * @param {?} reqInfo
         * @return {?}
         */
        InMemoryDataService.prototype.delete = /**
         * @param {?} reqInfo
         * @return {?}
         */
        function (reqInfo) {
            /** @type {?} */
            var response$;
            // Caso tenha um interceptador, retorna a resposta do mesmo
            response$ = this.processInterceptResponse(reqInfo, { id: reqInfo.id });
            if (response$) {
                return this.addDelay(response$, reqInfo.utils.getConfig().delay);
            }
            // Caso não tenha a collection, repassa a requisição para o backend verdadeiro
            // Para testes e2e usa o banco de dados em memória mesmo
            if (this.config.memoryOnly) {
                if (!this.dbe2e.has(reqInfo.collectionName)) {
                    return undefined;
                }
            }
            else {
                if (!this.db.objectStoreNames.contains(reqInfo.collectionName)) {
                    return undefined;
                }
            }
            response$ = this.delete$(reqInfo.collectionName, reqInfo.id, reqInfo.url);
            return this.addDelay(response$, reqInfo.utils.getConfig().delay);
        };
        /**
         * @private
         * @param {?} collection
         * @param {?} id
         * @return {?}
         */
        InMemoryDataService.prototype.removeById = /**
         * @private
         * @param {?} collection
         * @param {?} id
         * @return {?}
         */
        function (collection, id) {
            /** @type {?} */
            var ix = this.indexOf(collection, id);
            if (ix > -1) {
                collection.splice(ix, 1);
                return true;
            }
            return false;
        };
        /**
         * @private
         * @param {?} interceptor
         * @param {?} uriInfo
         * @return {?}
         */
        InMemoryDataService.prototype.compareRequestInterceptor = /**
         * @private
         * @param {?} interceptor
         * @param {?} uriInfo
         * @return {?}
         */
        function (interceptor, uriInfo) {
            /** @type {?} */
            var interceptorPathOk = true;
            /** @type {?} */
            var intPaths = angularInMemoryWebApi.removeTrailingSlash(interceptor.path.trim()).split('/');
            /** @type {?} */
            var uriPaths = angularInMemoryWebApi.removeTrailingSlash(uriInfo.path).split('/');
            // Se possui o mesmo número de segmentos na URL
            interceptorPathOk = intPaths.length === uriPaths.length;
            if (interceptorPathOk) {
                // Avalia se todos os segmentos são iguais
                for (var i = 0; i < intPaths.length && interceptorPathOk; i++) {
                    // Se é um segmento 'coriga' descarta o mesmo.
                    // Utilizado para intercepatar urls tipo: /api/parent/:id/child/:id/action
                    if (intPaths[i] === '**') {
                        continue;
                    }
                    interceptorPathOk = intPaths[i] === uriPaths[i];
                }
            }
            if (interceptorPathOk) {
                if (interceptor.query) {
                    /** @type {?} */
                    var interceptorQuery = (interceptor.query instanceof http.HttpParams) ? interceptor.query.toString() : interceptor.query;
                    /** @type {?} */
                    var uriInfoQuery = uriInfo.query ? decodeURI(uriInfo.query) : '';
                    if (interceptorQuery.length < uriInfoQuery.length) {
                        return interceptorQuery === uriInfoQuery.substr(0, interceptorQuery.length);
                    }
                    else {
                        return uriInfoQuery.length ? uriInfoQuery === interceptorQuery.substr(0, uriInfoQuery.length) : true;
                    }
                }
                else {
                    return true;
                }
            }
            return false;
        };
        /**
         * @private
         * @return {?}
         */
        InMemoryDataService.prototype.getResponseUtils = /**
         * @private
         * @return {?}
         */
        function () {
            return {
                responseFn: this.createResponseOptions.bind(this),
                errorResponseFn: this.createErrorResponseOptions.bind(this)
            };
        };
        /**
         * @private
         * @param {?} reqInfo
         * @param {?=} body
         * @return {?}
         */
        InMemoryDataService.prototype.processInterceptResponse = /**
         * @private
         * @param {?} reqInfo
         * @param {?=} body
         * @return {?}
         */
        function (reqInfo, body) {
            /** @type {?} */
            var response = this.interceptResponse(reqInfo, body);
            if (response instanceof rxjs.Observable) {
                return response;
            }
            if (response !== undefined) {
                return new rxjs.Observable((/**
                 * @param {?} observer
                 * @return {?}
                 */
                function (observer) {
                    if (response instanceof http.HttpErrorResponse) {
                        observer.error(response);
                    }
                    else {
                        observer.next(response);
                        observer.complete();
                    }
                }));
            }
            return undefined;
        };
        /**
         * @private
         * @param {?} reqInfo
         * @param {?=} body
         * @return {?}
         */
        InMemoryDataService.prototype.interceptResponse = /**
         * @private
         * @param {?} reqInfo
         * @param {?=} body
         * @return {?}
         */
        function (reqInfo, body) {
            /** @type {?} */
            var response;
            /** @type {?} */
            var interceptor = reqInfo.utils['responseInterceptor'];
            if (interceptor) {
                if (reqInfo.method === interceptor.method.toLocaleLowerCase()) {
                    if (interceptor.response) {
                        if (interceptor.response instanceof Function) {
                            response = interceptor.response.call(this, reqInfo.url, this.responseUtils, body);
                        }
                        else if (interceptor.response instanceof http.HttpResponse ||
                            interceptor.response instanceof http.HttpErrorResponse) {
                            response = this.clone(interceptor.response);
                        }
                    }
                }
                delete reqInfo.utils['responseInterceptor'];
            }
            return response;
        };
        /**
         * @param {?} url
         * @param {?} reqInfoUtils
         * @return {?}
         */
        InMemoryDataService.prototype.parseRequestUrl = /**
         * @param {?} url
         * @param {?} reqInfoUtils
         * @return {?}
         */
        function (url, reqInfoUtils) {
            var _this = this;
            var e_1, _a;
            console.log('[In-Memory]', 'Request: ', url);
            /** @type {?} */
            var self = this;
            /** @type {?} */
            var config = reqInfoUtils.getConfig();
            /** @type {?} */
            var start = config.host.length;
            try {
                for (var _b = __values(this.replaceMap.entries()), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var item = _c.value;
                    if (url.includes(item[0], start)) {
                        url = url.replace(item[0], item[1]);
                        break;
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_1) throw e_1.error; }
            }
            /** @type {?} */
            var parsed;
            try {
                parsed = reqInfoUtils.parseRequestUrl(url);
            }
            catch (err) {
                /** @type {?} */
                var msg = 'unable to parse url \'' + url + '\'; original error: ' + err.message;
                throw new Error(msg);
            }
            if (this.requestInterceptors.length > 0) {
                /** @type {?} */
                var uriInfo_1 = reqInfoUtils.getLocation(url);
                /** @type {?} */
                var interceptor = this.requestInterceptors.find((/**
                 * @param {?} value
                 * @return {?}
                 */
                function (value) {
                    /** @type {?} */
                    var intercept = value;
                    if (value.path.indexOf('{0}') >= 0 && parsed.id) {
                        intercept = _this.clone(value);
                        intercept.path = intercept.path.replace('{0}', parsed.id);
                    }
                    return self.compareRequestInterceptor(intercept, uriInfo_1);
                }));
                if (interceptor) {
                    reqInfoUtils['responseInterceptor'] = interceptor;
                }
            }
            return parsed;
        };
        return InMemoryDataService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var dataServiceFn = new Map();
    /** @type {?} */
    var memoryConfig = {
        delay: 0,
        host: 'http://localhost:1080',
        apiBase: 'api/v1',
        passThruUnknownUrl: true,
        post204: false,
        put204: false,
        memoryOnly: false,
        databaseName: 'in-memory-database'
    };
    /**
     * @return {?}
     */
    function getMemoryConfig() {
        return memoryConfig;
    }
    /**
     * @param {?} collectionName
     * @param {?} loadFn
     * @return {?}
     */
    function dataService(collectionName, loadFn) {
        dataServiceFn.set(collectionName, loadFn);
    }
    /** @type {?} */
    var dbService = new InMemoryDataService();
    /**
     * @return {?}
     */
    function getDbService() {
        return dbService;
    }
    /**
     * @param {?=} config
     * @return {?}
     */
    function setupMemory(config) {
        if (config) {
            Object.assign(memoryConfig, config);
        }
        /** @type {?} */
        var result$ = new Promise((/**
         * @param {?} resolve
         * @param {?} reject
         * @return {?}
         */
        function (resolve, reject) {
            dbService.deleteDatabase().then((/**
             * @return {?}
             */
            function () {
                dbService.createDatabase().then((/**
                 * @return {?}
                 */
                function () {
                    if (dataServiceFn && dataServiceFn.size > 0) {
                        dbService.createObjectStore(dataServiceFn).then((/**
                         * @return {?}
                         */
                        function () {
                            console.log('[In-Memory]', 'Database data created!');
                            resolve(true);
                        }), (/**
                         * @param {?} error
                         * @return {?}
                         */
                        function (error) {
                            console.error('[In-Memory]', error);
                            reject(error);
                        }));
                    }
                    else {
                        console.warn('[In-Memory]', 'There is not collection in data service!');
                        resolve(true);
                    }
                }), (/**
                 * @param {?} error
                 * @return {?}
                 */
                function (error) {
                    console.error('[In-Memory]', error);
                    reject(error);
                }));
            }), (/**
             * @param {?} error
             * @return {?}
             */
            function (error) {
                console.error('[In-Memory]', error);
                reject(error);
            }));
        }));
        return result$;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var InMemoryDataModule = /** @class */ (function () {
        function InMemoryDataModule() {
        }
        /**
         * @return {?}
         */
        InMemoryDataModule.forRoot = /**
         * @return {?}
         */
        function () {
            return {
                ngModule: InMemoryDataModule,
                providers: [
                    {
                        provide: angularInMemoryWebApi.InMemoryDbService,
                        useValue: getDbService()
                    },
                    {
                        provide: angularInMemoryWebApi.InMemoryBackendConfig,
                        useValue: getMemoryConfig()
                    },
                    {
                        provide: http.HttpBackend,
                        useFactory: httpClientInMemBackendServiceFactory,
                        deps: [
                            angularInMemoryWebApi.InMemoryDbService,
                            angularInMemoryWebApi.InMemoryBackendConfig,
                            http.XhrFactory
                        ]
                    }
                ]
            };
        };
        InMemoryDataModule.decorators = [
            { type: core.NgModule, args: [{},] }
        ];
        return InMemoryDataModule;
    }());

    exports.InMemoryDataModule = InMemoryDataModule;
    exports.InMemoryDataService = InMemoryDataService;
    exports.dataService = dataService;
    exports.dataServiceFn = dataServiceFn;
    exports.dbService = dbService;
    exports.getDbService = getDbService;
    exports.getMemoryConfig = getMemoryConfig;
    exports.httpClientInMemBackendServiceFactory = httpClientInMemBackendServiceFactory;
    exports.memoryConfig = memoryConfig;
    exports.setupMemory = setupMemory;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=totvs-log-web-foundation-src-in-memory-data.umd.js.map
