(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@progress/kendo-angular-grid'), require('@portinari/portinari-ui'), require('totvs-log-web-foundation'), require('@angular/forms'), require('@progress/kendo-angular-dropdowns'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('totvs-log-web-foundation/src/kendo-grid', ['exports', '@angular/core', '@progress/kendo-angular-grid', '@portinari/portinari-ui', 'totvs-log-web-foundation', '@angular/forms', '@progress/kendo-angular-dropdowns', '@angular/common'], factory) :
    (global = global || self, factory((global['totvs-log-web-foundation'] = global['totvs-log-web-foundation'] || {}, global['totvs-log-web-foundation'].src = global['totvs-log-web-foundation'].src || {}, global['totvs-log-web-foundation'].src['kendo-grid'] = {}), global.ng.core, global.kendoAngularGrid, global.portinariUi, global['totvs-log-web-foundation'], global.ng.forms, global.kendoAngularDropdowns, global.ng.common));
}(this, function (exports, core, kendoAngularGrid, portinariUi, totvsLogWebFoundation, forms, kendoAngularDropdowns, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var KendoGridExportComponent = /** @class */ (function () {
        function KendoGridExportComponent(grid, el, renderer) {
            this.grid = grid;
            this.el = el;
            this.renderer = renderer;
            this.popupActionsExport = [
                {
                    label: 'PDF',
                    action: this.exportAsPDF
                },
                {
                    label: 'Excel',
                    action: this.exportAsExcel
                }
            ];
            this._posInGroup = false;
        }
        Object.defineProperty(KendoGridExportComponent.prototype, "posInGroup", {
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                this._posInGroup = convertToBoolean(value);
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        KendoGridExportComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            if (this._posInGroup) {
                this.renderer.removeChild(this.el.nativeElement, ((/** @type {?} */ (this.el.nativeElement))).children[0]);
                this.renderer.addClass(this.renderer.parentNode(this.el.nativeElement), 'k-grid-toolbar-hidden');
            }
        };
        /**
         * @return {?}
         */
        KendoGridExportComponent.prototype.exportAsPDF = /**
         * @return {?}
         */
        function () {
            this.grid.saveAsPDF();
        };
        /**
         * @return {?}
         */
        KendoGridExportComponent.prototype.exportAsExcel = /**
         * @return {?}
         */
        function () {
            this.grid.saveAsExcel();
        };
        KendoGridExportComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'lib-kendo-grid-export',
                        template: "<span name=\"k-grid-export-space\">&nbsp;</span>\n<div class=\"k-grid-export\">\n  <span\n    #export\n    class=\"po-icon po-icon-export\"\n    p-tooltip=\"Exportar\"\n    p-tooltip-position=\"top\"\n    (click)=\"popup.toggle()\">\n  </span>\n  <po-popup\n    #popup\n    p-position=\"left\"\n    [p-target]=\"export\"\n    [p-actions]=\"popupActionsExport\">\n  </po-popup>\n</div>\n",
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        KendoGridExportComponent.ctorParameters = function () { return [
            { type: kendoAngularGrid.GridComponent, decorators: [{ type: core.Host }] },
            { type: core.ElementRef },
            { type: core.Renderer2 }
        ]; };
        KendoGridExportComponent.propDecorators = {
            posInGroup: [{ type: core.Input, args: ['pos-in-group',] }]
        };
        return KendoGridExportComponent;
    }());
    /**
     * @param {?} val
     * @return {?}
     */
    function convertToBoolean(val) {
        if (typeof val === 'string') {
            val = val.toLowerCase().trim();
            return (val === 'true' || val === 'on' || val === '');
        }
        if (typeof val === 'number') {
            return val === 1;
        }
        return !!val;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var KendoGridExportModule = /** @class */ (function () {
        function KendoGridExportModule() {
        }
        KendoGridExportModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [
                            KendoGridExportComponent
                        ],
                        imports: [
                            kendoAngularGrid.GridModule,
                            portinariUi.PoPopupModule
                        ],
                        exports: [
                            KendoGridExportComponent
                        ]
                    },] }
        ];
        return KendoGridExportModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var flatten = (/**
     * @param {?} filter
     * @return {?}
     */
    function (filter) {
        /** @type {?} */
        var filters = (filter || {}).filters;
        if (filters) {
            return filters.reduce((/**
             * @param {?} acc
             * @param {?} curr
             * @return {?}
             */
            function (acc, curr) { return acc.concat(curr.filters ? flatten(curr) : [curr]); }), []);
        }
        return [];
    });
    var KendoGridFilterEnumComponent = /** @class */ (function () {
        function KendoGridFilterEnumComponent(global) {
            this.global = global;
            this.options = [];
            this.selectedOptions = [];
        }
        /**
         * @return {?}
         */
        KendoGridFilterEnumComponent.prototype.filterOptions = /**
         * @return {?}
         */
        function () {
            var _a;
            (_a = this.selectedOptions).splice.apply(_a, __spread([0, this.selectedOptions.length], flatten(this.currentFilter).map((/**
             * @param {?} __0
             * @return {?}
             */
            function (_a) {
                var value = _a.value;
                return value;
            }))));
            return this.selectedOptions;
        };
        /**
         * @param {?} values
         * @return {?}
         */
        KendoGridFilterEnumComponent.prototype.changeFiltro = /**
         * @param {?} values
         * @return {?}
         */
        function (values) {
            var _this = this;
            this.filterService.filter({
                filters: values.map((/**
                 * @param {?} value
                 * @return {?}
                 */
                function (value) { return ({
                    field: _this.field,
                    operator: _this.applyFilter.bind(_this),
                    value: value,
                    ignoreCase: false
                }); })),
                logic: 'or'
            });
        };
        /**
         * @param {?} instance
         * @param {?} valor
         * @param {?} ignoreCase
         * @return {?}
         */
        KendoGridFilterEnumComponent.prototype.applyFilter = /**
         * @param {?} instance
         * @param {?} valor
         * @param {?} ignoreCase
         * @return {?}
         */
        function (instance, valor, ignoreCase) {
            /** @type {?} */
            var instanceValue = instance.hasOwnProperty('value') ? instance.value : instance.toString();
            return instanceValue === valor;
        };
        KendoGridFilterEnumComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'lib-kendo-grid-filter-enum',
                        template: "<kendo-multiselect\n  [placeholder]=\"placeholder\"\n  [data]=\"options\"\n  textField=\"label\"\n  valueField=\"value\"\n  [valuePrimitive]=\"true\"\n  [value]=\"filterOptions()\"\n  (valueChange)=\"changeFiltro($event)\">\n  <kendo-multiselect-messages\n    [clearTitle]=\"global.i18n.literals['clearTitle']\"\n    [noDataText]=\"global.i18n.literals['nenhumDadoEncontrado']\">\n  </kendo-multiselect-messages>\n</kendo-multiselect>\n",
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        KendoGridFilterEnumComponent.ctorParameters = function () { return [
            { type: totvsLogWebFoundation.GlobalService }
        ]; };
        KendoGridFilterEnumComponent.propDecorators = {
            currentFilter: [{ type: core.Input }],
            filterService: [{ type: core.Input }],
            field: [{ type: core.Input }],
            placeholder: [{ type: core.Input }],
            options: [{ type: core.Input }]
        };
        return KendoGridFilterEnumComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var KendoGridFilterEnumModule = /** @class */ (function () {
        function KendoGridFilterEnumModule() {
        }
        KendoGridFilterEnumModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [
                            KendoGridFilterEnumComponent
                        ],
                        imports: [
                            kendoAngularGrid.GridModule,
                            forms.FormsModule,
                            kendoAngularDropdowns.DropDownsModule
                        ],
                        exports: [
                            KendoGridFilterEnumComponent
                        ]
                    },] }
        ];
        return KendoGridFilterEnumModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var KendoGridMessagesComponent = /** @class */ (function () {
        function KendoGridMessagesComponent(global, changeDetectorRef) {
            this.global = global;
            this.changeDetectorRef = changeDetectorRef;
        }
        /**
         * @return {?}
         */
        KendoGridMessagesComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            this.changeDetectorRef.detectChanges();
        };
        KendoGridMessagesComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'lib-kendo-grid-messages',
                        template: "<kendo-grid-messages\n    [noRecords]=\"global.i18n.literals['nenhumDadoEncontrado']\"\n    [columnMenu]=\"global.i18n.literals['opcoesDaColuna']\"\n    [columns]=\"global.i18n.literals['colunaMenuGrid']\"\n    [filter]=\"global.i18n.literals['filtroMenuGrid']\"\n    [sortAscending]=\"global.i18n.literals['ordenarMenuGrid']\"\n    [sortDescending]=\"global.i18n.literals['ordenarMenuGrid']\"\n    [columnsApply]=\"global.i18n.literals['colunasAplicarMenuGrid']\"\n    [groupPanelEmpty]=\"global.i18n.literals['arrasteAColunaGridMessagem']\"\n    [columnsReset]=\"global.i18n.literals['colunasRestaurarMenuGrid']\"\n    [filterClearButton]=\"global.i18n.literals['colunasRestaurarMenuGrid']\"\n    [filterAfterOperator]=\"global.i18n.literals['depoisFiltroGrid']\"\n    [filterAfterOrEqualOperator]=\"global.i18n.literals['depoisOuIgualFiltroGrid']\"\n    [filterBooleanAll]=\"global.i18n.literals['todosBooleanFiltroGrid']\"\n    [filterContainsOperator]=\"global.i18n.literals['contemFiltroGrid']\"\n    [filterEndsWithOperator]=\"global.i18n.literals['terminaComFiltroGrid']\"\n    [filterAndLogic]=\"global.i18n.literals['eLogicoFiltroGrid']\"\n    [filterBeforeOperator]=\"global.i18n.literals['antesFiltroGrid']\"\n    [filterBeforeOrEqualOperator]=\"global.i18n.literals['anteriorOuIgualFiltroGrid']\"\n    [filterEqOperator]=\"global.i18n.literals['eIgualFiltroGrid']\"\n    [filterFilterButton]=\"global.i18n.literals['filtroGrid']\"\n    [filterGtOperator]=\"global.i18n.literals['eMelhorQueFiltroGrid']\"\n    [filterGteOperator]=\"global.i18n.literals['eMaiorQueOuIgualFiltroGrid']\"\n    [filterIsEmptyOperator]=\"global.i18n.literals['estaVaziaFiltroGrid']\"\n    [filterIsNotEmptyOperator]=\"global.i18n.literals['naoEstaVaziaFiltroGrid']\"\n    [filterIsNotNullOperator]=\"global.i18n.literals['naoNuloFiltroGrid']\"\n    [filterIsNullOperator]=\"global.i18n.literals['eNuloFiltroGrid']\"\n    [filterIsTrue]=\"global.i18n.literals['verdadeiroFiltroGrid']\"\n    [filterLtOperator]=\"global.i18n.literals['eMenosDoQueFIltroGrid']\"\n    [filterLteOperator]=\"global.i18n.literals['eMenorOuIgualFiltroGrid']\"\n    [filterNotContainsOperator]=\"global.i18n.literals['naoContemFiltroGrid']\"\n    [filterNotEqOperator]=\"global.i18n.literals['naoIgualFiltroGrid']\"\n    [filterOrLogic]=\"global.i18n.literals['ouLogicoFiltroGrid']\"\n    [filterStartsWithOperator]=\"global.i18n.literals['comecaComFiltroGrid']\">\n</kendo-grid-messages>\n",
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        KendoGridMessagesComponent.ctorParameters = function () { return [
            { type: totvsLogWebFoundation.GlobalService },
            { type: core.ChangeDetectorRef }
        ]; };
        return KendoGridMessagesComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var KendoGridMessagesModule = /** @class */ (function () {
        function KendoGridMessagesModule() {
        }
        KendoGridMessagesModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [
                            KendoGridMessagesComponent
                        ],
                        imports: [
                            kendoAngularGrid.GridModule
                        ],
                        exports: [
                            KendoGridMessagesComponent
                        ]
                    },] }
        ];
        return KendoGridMessagesModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ToolTipInKGridDirective = /** @class */ (function () {
        function ToolTipInKGridDirective(el, tooltip) {
            this.el = el;
            this.tooltip = tooltip;
        }
        /**
         * @return {?}
         */
        ToolTipInKGridDirective.prototype.ngAfterViewInit = /**
         * @return {?}
         */
        function () {
            ((/** @type {?} */ (this.el.nativeElement))).removeAllListeners('mouseenter');
            if (this.tooltip) {
                ((/** @type {?} */ (this.el.nativeElement))).addEventListener('mouseover', this.showTooltip.bind(this));
                // tslint:disable-next-line: no-string-literal
                this.tooltip['createTooltip']();
                this.tooltip.onMouseLeave();
            }
        };
        /**
         * @param {?} e
         * @return {?}
         */
        ToolTipInKGridDirective.prototype.showTooltip = /**
         * @param {?} e
         * @return {?}
         */
        function (e) {
            /** @type {?} */
            var element = (/** @type {?} */ (e.target));
            if ((element.nodeName === 'TD' || element.nodeName === 'TH' ||
                element.parentNode.nodeName === 'TD' || element.parentNode.nodeName === 'TH')
                && element.offsetWidth < element.scrollWidth) {
                this.tooltip.tooltip = element.innerText;
                // tslint:disable-next-line: no-string-literal
                this.tooltip['poControlPosition'].setElements(this.tooltip['tooltipContent'], this.tooltip['tooltipOffset'], element);
                this.tooltip.onMouseEnter();
            }
            else {
                this.tooltip.onMouseLeave();
            }
        };
        ToolTipInKGridDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: '[libToolTipInKGrid]'
                    },] }
        ];
        /** @nocollapse */
        ToolTipInKGridDirective.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: portinariUi.PoTooltipDirective, decorators: [{ type: core.Host }, { type: core.Optional }] }
        ]; };
        return ToolTipInKGridDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TooltipInKGridModule = /** @class */ (function () {
        function TooltipInKGridModule() {
        }
        TooltipInKGridModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [ToolTipInKGridDirective],
                        imports: [
                            common.CommonModule,
                        ],
                        exports: [ToolTipInKGridDirective]
                    },] }
        ];
        return TooltipInKGridModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * \@dynamic
     */
    var FixComboInKGridDirective = /** @class */ (function () {
        function FixComboInKGridDirective(el, document) {
            this.el = el;
            this.document = document;
        }
        /**
         * @return {?}
         */
        FixComboInKGridDirective.prototype.ngAfterViewChecked = /**
         * @return {?}
         */
        function () {
            /** @type {?} */
            var container = this.el.nativeElement.querySelector('.po-combo-container');
            if (container) {
                this.document.body.appendChild(container);
            }
        };
        FixComboInKGridDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: '[libFixComboInKGrid]'
                    },] }
        ];
        /** @nocollapse */
        FixComboInKGridDirective.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: Document, decorators: [{ type: core.Inject, args: [common.DOCUMENT,] }] }
        ]; };
        return FixComboInKGridDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FixComboInKGridModule = /** @class */ (function () {
        function FixComboInKGridModule() {
        }
        FixComboInKGridModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [FixComboInKGridDirective],
                        imports: [
                            common.CommonModule,
                        ],
                        exports: [FixComboInKGridDirective]
                    },] }
        ];
        return FixComboInKGridModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // @dynamic
    var FndKendoGridModule = /** @class */ (function () {
        function FndKendoGridModule() {
        }
        FndKendoGridModule.decorators = [
            { type: core.NgModule, args: [{
                        exports: [
                            kendoAngularGrid.GridModule,
                            kendoAngularGrid.PDFModule,
                            kendoAngularGrid.ExcelModule,
                            KendoGridMessagesModule,
                            KendoGridExportModule,
                            KendoGridFilterEnumModule,
                            TooltipInKGridModule,
                            FixComboInKGridModule
                        ]
                    },] }
        ];
        return FndKendoGridModule;
    }());

    exports.FixComboInKGridDirective = FixComboInKGridDirective;
    exports.FixComboInKGridModule = FixComboInKGridModule;
    exports.FndKendoGridModule = FndKendoGridModule;
    exports.KendoGridExportComponent = KendoGridExportComponent;
    exports.KendoGridExportModule = KendoGridExportModule;
    exports.KendoGridFilterEnumComponent = KendoGridFilterEnumComponent;
    exports.KendoGridFilterEnumModule = KendoGridFilterEnumModule;
    exports.KendoGridMessagesComponent = KendoGridMessagesComponent;
    exports.KendoGridMessagesModule = KendoGridMessagesModule;
    exports.ToolTipInKGridDirective = ToolTipInKGridDirective;
    exports.TooltipInKGridModule = TooltipInKGridModule;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=totvs-log-web-foundation-src-kendo-grid.umd.js.map
