import { InjectionToken } from '@angular/core';
import { PoI18nConfig } from '@portinari/portinari-ui';
import { I18nBaseService } from 'totvs-log-base-foundation';
import { IIntlConfig } from './intl-config.interface';
import { IntlLiteralsLoaderService } from './intl-literal-loader.service';
/**
 * Token de configuração da url de internacionalização
 */
export declare const INTL_CONFIG: InjectionToken<IIntlConfig>;
/**
 * Serviço de internacionalização
 */
export declare class IntlService extends I18nBaseService {
    /**
     * Atributo com as configurações de internacionalização
     */
    static i18nConfig: PoI18nConfig;
    /**
     * Método construtor da classe
     * @param config Parâmetro do serviço com as configurações de internacionalização
     * @param intlLiteralsLoader Parâmetro do serviço de carregamento de literais de internacionalização
     */
    constructor(config: IIntlConfig, intlLiteralsLoader: IntlLiteralsLoaderService);
}
