import { ShowMessageLinkActionType } from 'totvs-log-base-foundation';
import { PoModalComponent } from '@portinari/portinari-ui';
/**
 * Classe/componente de mensagem
 */
export declare class MessageComponent {
    /**
     * Atributo que recebe a referência do componente PoModalComponent no HTML
     */
    poModal: PoModalComponent;
    /**
     * Atributo com o título da mensagem
     */
    messageTitle: string;
    /**
     * Atributo com o texto da mensagem
     */
    messageText: string;
    /**
     * Atributo com os detalhes da mensagem
     */
    messageDetails: string;
    /**
     * Atributo que recebe a ação de confirmação
     */
    messageConfirmAction: any;
    /**
     * Atributo que recebe a ação de cancelamento
     */
    messageCancelAction: any;
    /**
     * Atributo que recebe o tipo do link
     */
    messageLinkActionType: ShowMessageLinkActionType;
    /**
     * Atributo que recebe o link
     */
    messageLinkAction: any;
    /**
     * Atributo que recebe o label do link
     */
    messageLinkLabel: string;
    /**
     * Atributo que indica se os detalhes da mensagem devem ser escondidos
     */
    hideDetails: boolean;
    /**
     * Método responsável por disparar a abertura da dialog
     */
    openDialog(): void;
    /**
     * Método responsável por fechar a dialog
     */
    closeDialog(): void;
    /**
     * Método responsável por executar ação do link relacionado a mensagem
     */
    linkAction(): void;
}
