import { InMemoryDataService } from './in-memory-data.service';
import { HttpErrorResponse, HttpParams, HttpResponse } from '@angular/common/http';
import { InMemoryBackendConfigArgs } from 'angular-in-memory-web-api';
export declare type LoadFn = (dbService: InMemoryDataService) => void;
export declare type TransformFn = (value: any, dbService: InMemoryDataService) => any;
export declare type TransformPutFn = (item: any, body: any) => any;
export declare type FilterFn = (value: any, item: any) => boolean;
export declare type ErrorResponseFn = (url: string, status: number, message: string, detailedMessage?: string) => HttpErrorResponse;
export declare type ResponseFn = (url: string, status: number, body?: any) => HttpResponse<any>;
export declare type ResponseInterceptorFn = (url: string, utils: IResponseUtils, body?: any) => HttpResponse<any> | HttpErrorResponse;
export interface IMemoryConfig extends InMemoryBackendConfigArgs {
    databaseName: string;
    memoryOnly: boolean;
}
export interface IResponseUtils {
    responseFn: ResponseFn;
    errorResponseFn: ErrorResponseFn;
}
export interface IRequestInterceptor {
    method?: string;
    path: string;
    query?: HttpParams | string;
    response: ResponseInterceptorFn | HttpResponse<any> | HttpErrorResponse;
}
export interface IQueryFilter {
    name: string;
    rx?: RegExp;
    fn?: FilterFn;
}
export interface IQueryParams {
    count: number;
    page?: number;
    pageSize?: number;
    conditions?: Array<IQueryFilter>;
    useFilterOr?: boolean;
}
export interface IQueryResult {
    hasNext: boolean;
    items: Array<any>;
}
