import { InMemoryDbService, ParsedRequestUrl, RequestInfo, RequestInfoUtilities } from 'angular-in-memory-web-api';
import { Observable } from 'rxjs';
import { FilterFn, IRequestInterceptor, LoadFn, TransformFn, TransformPutFn } from './in-memory-data.interface';
export declare class InMemoryDataService implements InMemoryDbService {
    private config;
    private loadsFn;
    private requestInterceptors;
    private replaceMap;
    private searchTermMap;
    private transformGetMap;
    private transformPostMap;
    private transformPutMap;
    private fieldsFilterMap;
    private db;
    private dbe2e;
    private responseUtils;
    constructor();
    createDb(): Observable<{}>;
    deleteDatabase(): Promise<boolean>;
    createDatabase(): Promise<boolean>;
    createObjectStore(dataServiceFn: Map<string, LoadFn>): Promise<boolean>;
    storeData(collectionName: string, data: any): Promise<string>;
    clearData(collectionName: string): Promise<boolean>;
    addRequestInterceptor(requestInterceptor: IRequestInterceptor): void;
    addReplaceUrl(key: string, value: string): void;
    addSearchTermMap(collectionName: string, fields: string[]): void;
    addTransformGetMap(collectionName: string, transformfn: TransformFn): void;
    addTransformPostMap(collectionName: string, transformfn: TransformFn): void;
    addTransformPutMap(collectionName: string, transformfn: TransformPutFn): void;
    addFieldFilterMap(collectionName: string, field: string, filterfn: FilterFn): void;
    addRequestInterceptorByValue(value: any): void;
    private getFieldFilterMap;
    private clone;
    private createErrorResponseOptions;
    private createResponseOptions;
    private filterItem;
    private filterItemAnd;
    private filterItemOr;
    private createFilterFn;
    private createFilterUnidadeFn;
    private createFilterArrayFn;
    private addDelay;
    private getQueryParams;
    private getAllItems;
    private findById;
    private indexOf;
    getInstance$(collectionName: string, id: string): Observable<{}>;
    get$(collectionName: string, id: string, query: Map<string, string[]>, url: string, caseSensitiveSearch?: string): Observable<any>;
    get(reqInfo: RequestInfo): Observable<{}>;
    put$(collectionName: string, id: any, item: any, url: string): Observable<any>;
    put(reqInfo: RequestInfo): Observable<{}>;
    post$(collectionName: string, item: any, url: string): Observable<any>;
    post(reqInfo: RequestInfo): Observable<{}>;
    delete$(collectionName: string, id: any, url: string): Observable<any>;
    delete(reqInfo: RequestInfo): Observable<{}>;
    private removeById;
    private compareRequestInterceptor;
    private getResponseUtils;
    private processInterceptResponse;
    private interceptResponse;
    parseRequestUrl(url: string, reqInfoUtils: RequestInfoUtilities): ParsedRequestUrl;
}
